#version 330

in vec4 position;
in vec3 normal;
in vec2 uv;

in vec4 tangent;

out vec3 N;
out vec3 V;
out vec3 P;
out vec2 fUVs;
out mat3 TBN;
out float flip;

uniform mat4 modelMatrix;
uniform mat4 normalMatrix;
uniform mat4 mvpMatrix;
uniform mat4 mvMatrix;
uniform vec3 cameraLocation;

//per spotlight
uniform vec3 lightLocation_0;
uniform mat4 shadowTexMatrix_0;
out vec3 L_0;
out vec4 shadowTexCoord_0;

uniform vec3 lightLocation_1;
uniform mat4 shadowTexMatrix_1;
out vec3 L_1;
out vec4 shadowTexCoord_1;
 
void main () {
	fUVs = uv;

	vec4 hP = modelMatrix * position;
	P = vec3(hP/hP.w);
    N = vec3(normalMatrix * vec4(normal,0));
	V = cameraLocation - P;

	L_0 = lightLocation_0 - P;
	shadowTexCoord_0 = shadowTexMatrix_0 * position;
	L_1 = lightLocation_1 - P;
	shadowTexCoord_1 = shadowTexMatrix_1 * position;

	if(N.x < 0.0) flip = -1.0;
	else flip = 1.0;
	vec3 tang = tangent.xyz;
	vec3 T = vec3(normalMatrix * vec4(tang,1.0));
	vec3 B = cross(N, T) * tangent.w;

	TBN = mat3(T.x, B.x, N.x,
			   T.y, B.y, N.y,
			   T.z, B.z, N.z);

    gl_Position = mvpMatrix * position; 
}