#version 330
//quelle https://developer.nvidia.com/sites/default/files/akamai/gamedev/docs/PCSS_Integration.pdf
//#define BLOCKER_SEARCH_NUM_SAMPLES 16
//#define PCF_NUM_SAMPLES 16
//#define NEAR_PLANE 9.5
//#define LIGHT_WORLD_SIZE 0.5
//#define LIGHT_FRUSTUM_WIDTH 3.75
//#define LIGHT_SIZE_UV (LIGHT_WORLD_SIZE / LIGHT_FRUSTUM_WIDTH)

in vec3 L;

uniform float opacity;
uniform int wireframe;

out vec4 colorOut;

void main() {
	if(wireframe == 1){
		colorOut = vec4(1.0,1.0,1.0,1.0);
	} else {
		vec4 colorLight;
		colorLight = vec4(0.9,0.9,1.0,1.0);
		
		float distance = length(L);
		float distanceFade = 1.0;
		if (distance > 14.0) {
			distanceFade = 0.0;
		} else if (distance > 8.0) {
			distanceFade = -((distance - 14.0) / 6.0);
		}
		
		colorOut = colorLight * distanceFade;
		if(opacity != 1.0) colorOut = vec4(colorOut.xyz,opacity);
	}
}
