#version 330

in vec4 position;
in vec2 uv;

out vec2 fUVs;
out vec3 L;

uniform mat4 modelMatrix;
uniform mat4 mvpMatrix;
uniform vec3 lightLocation;
 
void main () {
	fUVs = uv;

	vec4 hP = modelMatrix * position;
	vec3 P = vec3(hP/hP.w);
	L = lightLocation - P;

    gl_Position = mvpMatrix * position; 
}