#version 330

in vec2 fUVs;

out vec4 fragColor;

uniform sampler2D glowMap;
uniform sampler2D sceneMap;

void main(){
	vec3 glowColor = texture2D(glowMap, fUVs).xyz;
	vec3 sceneColor = texture2D(sceneMap, fUVs).xyz;

	//additive
	fragColor = vec4(glowColor + sceneColor, 1.0);

	//screen blending
	fragColor = vec4((glowColor + sceneColor) - (glowColor * sceneColor), 1.0);	
}