#version 330
 
in vec3 N;
in vec3 V;
in vec3 P;
in vec2 fUVs;

uniform float I;
uniform float ambient;
uniform sampler2D diffuseTexture;
uniform int wireframe;
out vec4 colorOut;
 
void main() {
	if(wireframe == 0){
		vec3 textureColor = texture(diffuseTexture, fUVs).rgb;

		vec3 N = normalize(N);
		vec3 V = normalize(V);

		//quelle http://www.roxlu.com/2014/037/opengl-rim-shader

		float rim = 1.0 - max(dot(V, N), 0.0); //rim-light anteil
		rim = smoothstep(0.6, 1.0, rim); //je kleiner der erste parameter, 
										 //desto weiter nach hinten wirkt das rim-light

		colorOut = vec4(I * textureColor * (rim + 0.05), 1.0);
		colorOut += vec4(textureColor * ambient / 2.0f + vec3(0.0,0.0,0.0) * (1.0-ambient/2.0f), 1.0); //TODO ambient statt 0.2
	} else {
		colorOut = vec4(1.0,1.0,1.0,1.0);
	}

	//colorOut += vec4(ambient, ambient, ambient, 0.0);
}