#version 330

in vec4 position;
in vec3 normal;
in vec2 uv;

out vec3 N;
out vec3 V;
out vec3 P;
out vec2 fUVs;

uniform mat4 modelMatrix;
uniform mat4 normalMatrix;
uniform mat4 mvpMatrix;
uniform vec3 cameraLocation;
 
void main () {
	fUVs = uv;

	vec4 hP = modelMatrix * position;
	P = vec3(hP/hP.w);
    N = vec3(normalMatrix * vec4(normal,0));
	V = cameraLocation - P;

    gl_Position = mvpMatrix * position; 
}